/* jshint node: true */
var path = require("path");
var gulp = require("gulp");
var serv = require("gulp-serv");
var livereload = require("gulp-livereload");
var sequence = require("run-sequence");

var strap      = require(".."),
    browserify = strap.browserify,
    less       = strap.less;

/*
 * browserify
 */

var _js = path.resolve(__dirname, "assets/javascripts");
var js_ = path.resolve(__dirname, "public/js");

gulp.task("browserify-multi", browserify(_js, js_, [
  {main: "index.js", out: "public.js", browserify: {}},
  {main: "admin.js", out: "admin.js", browserify: {}}
]));

gulp.task("browserify", browserify(_js, js_, {browserify: {}}));

/*
 * less
 */

var _less = path.resolve(__dirname, "assets/stylesheets");
var less_ = path.resolve(__dirname, "public/css");

gulp.task("less", less(_less, less_));

/*
 * watch
 */

gulp.task("watch", function() {
  livereload.listen();
  var ch = livereload.changed;
  gulp.watch([_less + "/**/*.less"], ["less"]).on("change", ch);
  gulp.watch([_js + "/**/*.js"], ["browserify"]).on("change", ch);
  gulp.watch([__dirname + "/public/*.html"]).on("change", ch);
});

/*
 * default
 */

gulp.task("default", ["watch"], function(done) {
  sequence(["browserify", "less"], function() {
    serv.start({
      root: __dirname + "/public",
      port: 8080
    }, done);
  });
});
